﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using Syncfusion.JavaScript;
using MvcApplication66.Models;
using System.Data.SqlClient;
using System.Configuration;
using System.Data;
using System.Web.Http.Cors;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        static string cons = ConfigurationManager.ConnectionStrings["NORTHWNDConnectionString"].ConnectionString;
        static SqlConnection con = new SqlConnection(cons);
        public ActionResult Index()
        {
            var dataSource = new NorthwindDataContext().OrdersViews.ToList();
            ViewBag.dataSource = dataSource;
            return View();
        }
        [EnableCors(origins: "*", headers: "*", methods: "*")]
        public string Query(string gridObj)
        {
            con.Open();
            var time = DateTime.Now.TimeOfDay.ToString();
            //Inserting Grid object into StateStore Table with respective time
            //States and CurrentTime are two columns in table
            //States have the corresponding object whereas the CurrentTime as time
            SqlCommand insert = new SqlCommand("INSERT INTO SaveModel (States,CurrentTime ) VALUES('" + gridObj + "','" + time + "')", con);
            insert.ExecuteNonQuery();
            con.Close();
            return time;//can be saved in ejDropDownList
        }
        [EnableCors(origins: "*", headers: "*", methods: "*")]
        public string Restate(string dropObject)
        {
            if (con.State != System.Data.ConnectionState.Open)
                con.Open();
            //Retrieving the Grid object from the StateStore Table based on the time
            SqlCommand take = new SqlCommand("SELECT States FROM SaveModel WHERE CurrentTime ='" + dropObject + "'", con);
            SqlDataAdapter da = new SqlDataAdapter(take);
            DataTable dt = new DataTable();
            da.Fill(dt);
            con.Close();
            return dt.Rows[0]["States"].ToString();
        }
        public ActionResult DataSource(Syncfusion.JavaScript.DataManager dm)
        {
            IEnumerable datasource = new NorthwindDataContext().OrdersViews.ToList();
            DataOperations operation = new DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0)
            {
                datasource = operation.PerformSorting(datasource, dm.Sorted);
            }
            if (dm.Where != null)
            {
                datasource = operation.PerformWhereFilter(datasource, dm.Where, dm.Where[0].Condition);
            }
            int count = datasource.AsQueryable().Count(); ;
            if (dm.Skip >= 0)//for paging
                datasource = operation.PerformSkip(datasource, dm.Skip);
            if (dm.Take > 0)//for paging
                datasource = operation.PerformTake(datasource, dm.Take);
            return Json(new { result = datasource, count = count }, JsonRequestBehavior.AllowGet);
        }
    }
}